#include <fstream.h>


#define INFILE   "culmi.in"
#define OUTFILE  "culmi.out"
#define MAX      10000

typedef unsigned int natural;

ifstream Fin(INFILE);
ofstream Fout(OUTFILE);

int X[MAX+1]; //X - vectorul initial;
int l[MAX+1], poz[MAX+1]; //l si poz - vector necesar pentru determinarea celui mai lung subsir crescator
natural N, NrS=0, Ne=0;      //NrS - numar subsiruri

void Gata()
{
  Fout<<NrS;
  Fin.close();
  Fout.close();
}

void Citire()
{
  natural i;
  Fin>>N;
  for(i=1; i<=N; i++) Fin>>X[i];
}

void CelMaiLungSubsirCrecator()
{
  natural i, j, n;
  for(i=1; i<=MAX; i++) l[i]=0;    //reinitializez vectorul l
  for(i=1; i<=MAX; i++) poz[i]=0;  //reinitializez vectorul poz
  n=N;                  //reinitializez n
  l[n]=1; poz[n]=-1;
  for (i=n-1; i>0; i--)
    if(X[i]>0)           //doar pemtru elementele X[i] ramase
      for (l[i]=1, poz[i]=-1, j=i+1; j<=n; j++)
	if (X[j]>0)      //doar pemtru elementele X[j] ramase
	  if (X[i] < X[j] && l[i]<1+l[j])
	    {
	      l[i]=1+l[j];
	      poz[i]=j;
	    }
}

void EliminaCMLSC()
{
  int i;
//Pentru a determina subsirul, determinam maximul din
//vectorul l, apoi eliminam solutia (pun -1), ncepnd cu pozitia
//maximului si utiliznd informatiile memorate n vectorul poz:
  //determin maximul din vectorul l
  int max=l[1], pozmax=1, n=N;
  for (i=2; i<=n; i++)
    if (max<l[i])
      {
	max=l[i];
	pozmax=i;
      }
//cout<<"Lungimea celui mai lung subsir crescator: " <<max;
//cout<<"\nCel mai lung subsir:\n";
  for (i=pozmax; i!=-1; i=poz[i])
    {
      cout<<X[i]<<' ';
      X[i]=0;
    }
  cout<<endl;
  Ne+=max; //lungimea sirului dupa eliminare
}

int main(void)
{
  Citire();
  while(Ne<N)
    {
     CelMaiLungSubsirCrecator();
     NrS++;
     EliminaCMLSC();
    }
  Gata();
  return(0);
}


