#include <stdlib.h>
#include <stdio.h>
#include <mem.h>

#define INFILE   "culmi.in"
#define OUTFILE  "culmi.out"
#define MAX      10001

typedef unsigned int natural;

natural X[MAX], S[MAX]; //X - vectorul initial; S[i] - ultimul element din subsirul i
natural N, NrS;         //NrS - numar subsiruri

FILE *Fin, *Fout;

void Init(void)
{
			//natural i;
  Fin = fopen(INFILE, "r+");
  Fout = fopen(OUTFILE, "w+");
  memset(S, 0, MAX);    //for(i=1; i<=MAX; S[i++]=0;)
}

void Gata(void)
{
  fclose(Fin);
  fclose(Fout);
}

void Citire(void)
{
  natural i;
  fscanf(Fin, "%u", &N);
  for(i=1; i<=N; i++) fscanf(Fin, "%u", &X[i]); 
}

void Subsiruri(void)
{
  natural i, j;
  S[1]=X[1];          //primul element va fi in subsirul 1
  NrS=1;              //am un subsir
  for(i=2; i<=N; i++) //iau pe rand elementele din vectorul X
    {                 //si caut primul subsir care are ultimul element
      j=1;            //strict mai mic ca acesta
      while((j<=NrS) && (X[i]<=S[j])) j++;
      if (j>NrS) NrS=j;//daca nu am gasit am un nou subsir
      S[j]=X[i];      //pun elementul ca ultim element in subsir
    }
  fprintf(Fout, "%u\n", NrS);
}

int main(void)
{
  Init();
  Citire();
  Subsiruri();
  Gata();
  return(0);
}