#include <iostream>
#include <fstream>

#define infile  "smith.in"
#define outfile "smith.out"

using namespace std;


int sumdig(long n)
{
	int s=0;
	do
	{	
		s+=n%10;
		n/=10;
	} while (n);
	return s;
}

int sumprim(long n)
{
	if (n<2) return 0;

	// caut primul divizor prim <= sqrt(n)	
	for (long i=2; i*i <= n; ++i)
		if (n%i==0)
		{
			return sumdig(i)+sumprim(n/i);
		}

	// daca nu am gasit nici unul numarul este prim
	return sumdig(n);
}

int main()
{
	int n, i;
	long t;

	// deschid fisierul de intrare
	ifstream fin(infile);
	if (!fin)
	{
		cout<<"Fisierul "<<infile<<" nu poate fi deschis"<<endl;
		return 0;
	}

	// deschid fisierul de iesire
	ofstream fout(outfile);
	if (!fout)
	{
		cout<<"Fisierul "<<outfile<<" nu poate fi deschis"<<endl;
		return 0;
	}

	// citesc datele de intrare si afisez rezultatele
	fin>>n;
	for (i=1; i<=n; ++i)
	{
		fin>>t;
		if (sumdig(t) == sumprim(t)) 
			fout<<"DA";
		else
			fout<<"NU";
		fout<<endl;
	}
	return 0;
}

